<template>
<component
	:is="self ? 'MkA' : 'a'" ref="el" class="xlcxczvw _link" :[attr]="self ? url.substr(local.length) : cleanUrl" :rel="rel" :target="target"
	:title="cleanUrl"
>
	<slot></slot>
	<i v-if="target === '_blank'" class="fas fa-external-link-square-alt icon"></i>
</component>
</template>

<script lang="ts" setup>
import { defineAsyncComponent } from 'vue';
import { url as local } from '@/config';
import { removeTracking } from '@/filters/url';
import { useTooltip } from '@/scripts/use-tooltip';
import * as os from '@/os';

const props = withDefaults(defineProps<{
	url: string;
	rel?: null | string;
}>(), {
});

const self = props.url.startsWith(local);
const attr = self ? 'to' : 'href';
const target = self ? null : '_blank';
const cleanUrl = self ? props.url : removeTracking(props.url);

const el = $ref();

useTooltip($$(el), (showing) => {
	os.popup(defineAsyncComponent(() => import('@/components/url-preview-popup.vue')), {
		showing,
		url: cleanUrl,
		source: el,
	}, {}, 'closed');
});
</script>

<style lang="scss" scoped>
.xlcxczvw {
	word-break: break-all;

	> .icon {
		padding-left: 2px;
		font-size: .9em;
	}
}
</style>
